var castaneum = require('castaneum'),
    sys = require('sys');

var Skillet = new castaneum.Skillet();

function scrape(res) {
  Skillet.readDocument(res.data, res.url, function(url, $) {
    $('#thumbTable a').forEach(function(el) {
      if (el.attributes._nodes['HREF']) {
        var href = el.attributes._nodes['HREF']._nodeValue;
      } else {
        var href = el.attributes._nodes['href']._nodeValue;
      }
      var targetUrl = new castaneum.Url(url.join(href));
      var targetFilename = res.url.digest_folder + '/' + targetUrl.filename;
      require('path').exists(targetFilename, function(exists) {
        if (!exists) {
          castaneum.get(new castaneum.Url(url.join(href)), function(err, targetRes) {
            if (err) throw err;

            targetRes.writeFile(targetFilename);
            sys.puts(targetRes.url.href);
          });
        }
      });
    });
  });
}

var queue = castaneum.createQueue('./urls.txt');
while (!queue.isEmpty()) {
  queue.dequeue(function(url) {
    castaneum.get(url, function(err, res) {
      if (err) throw err;

      console.log(res.statusCode + '  ' + res.url.href);
      if (res.statusCode == 200) {
        require('path').exists(res.url.digest_folder, function(exists) {
          if (!exists) {
            require('fs').mkdirSync(res.url.digest_folder, 0777);
          }
          res.writeFile(res.url.digest_filepath);
          scrape(res);
        });
      }
    });
  });
}
